diff --git a/salt/utils/cloud.py b/salt/utils/cloud.py
index 0485a7476a..0d59aaf7db 100644
--- a/salt/utils/cloud.py
+++ b/salt/utils/cloud.py
@@ -4,10 +4,9 @@ Utility functions for salt.cloud
 '''
 
 # Import python libs
-from __future__ import absolute_import
+from __future__ import absolute_import, print_function, unicode_literals
 import errno
 import os
-import sys
 import stat
 import codecs
 import shutil
@@ -26,16 +25,6 @@ import re
 import uuid
 
 
-# Let's import pwd and catch the ImportError. We'll raise it if this is not
-# Windows
-try:
-    import pwd
-except ImportError:
-    if not sys.platform.lower().startswith('win'):
-        # We can't use salt.utils.is_windows() from the import a little down
-        # because that will cause issues under windows at install time.
-        raise
-
 try:
     import salt.utils.smb
 
@@ -57,11 +46,17 @@ import salt.client
 import salt.config
 import salt.loader
 import salt.template
-import salt.utils
+import salt.utils.compat
+import salt.utils.crypt
+import salt.utils.data
 import salt.utils.event
-from salt.utils import vt
+import salt.utils.files
+import salt.utils.platform
+import salt.utils.stringutils
+import salt.utils.versions
+import salt.utils.vt
+import salt.utils.yaml
 from salt.utils.nb_popen import NonBlockingPopen
-from salt.utils.yamldumper import SafeOrderedDumper
 from salt.utils.validate.path import is_writeable
 
 # Import salt cloud libs
@@ -75,11 +70,18 @@ from salt.exceptions import (
     SaltCloudPasswordError
 )
 
-# Import third party libs
-import salt.ext.six as six
+# Import 3rd-party libs
+from salt.ext import six
 from salt.ext.six.moves import range  # pylint: disable=import-error,redefined-builtin,W0611
 from jinja2 import Template
-import yaml
+
+# Let's import pwd and catch the ImportError. We'll raise it if this is not
+# Windows. This import has to be below where we import salt.utils.platform!
+try:
+    import pwd
+except ImportError:
+    if not salt.utils.platform.is_windows():
+        raise
 
 try:
     import getpass
@@ -88,6 +90,10 @@ try:
 except ImportError:
     HAS_GETPASS = False
 
+# This is required to support international characters in AWS EC2 tags or any
+# other kind of metadata provided by particular Cloud vendor.
+MSGPACK_ENCODING = 'utf-8'
+
 NSTATES = {
     0: 'running',
     1: 'rebooting',
@@ -107,15 +113,15 @@ def __render_script(path, vm_=None, opts=None, minion=''):
     '''
     Return the rendered script
     '''
-    log.info('Rendering deploy script: {0}'.format(path))
+    log.info('Rendering deploy script: %s', path)
     try:
-        with salt.utils.fopen(path, 'r') as fp_:
-            template = Template(fp_.read())
-            return str(template.render(opts=opts, vm=vm_, minion=minion))
+        with salt.utils.files.fopen(path, 'r') as fp_:
+            template = Template(salt.utils.stringutils.to_unicode(fp_.read()))
+            return six.text_type(template.render(opts=opts, vm=vm_, minion=minion))
     except AttributeError:
         # Specified renderer was not found
-        with salt.utils.fopen(path, 'r') as fp_:
-            return fp_.read()
+        with salt.utils.files.fopen(path, 'r') as fp_:
+            return six.text_type(fp_.read())
 
 
 def os_script(os_, vm_=None, opts=None, minion=''):
@@ -161,10 +167,10 @@ def gen_keys(keysize=2048):
     salt.crypt.gen_keys(tdir, 'minion', keysize)
     priv_path = os.path.join(tdir, 'minion.pem')
     pub_path = os.path.join(tdir, 'minion.pub')
-    with salt.utils.fopen(priv_path) as fp_:
-        priv = fp_.read()
-    with salt.utils.fopen(pub_path) as fp_:
-        pub = fp_.read()
+    with salt.utils.files.fopen(priv_path) as fp_:
+        priv = salt.utils.stringutils.to_unicode(fp_.read())
+    with salt.utils.files.fopen(pub_path) as fp_:
+        pub = salt.utils.stringutils.to_unicode(fp_.read())
     shutil.rmtree(tdir)
     return priv, pub
 
@@ -181,12 +187,12 @@ def accept_key(pki_dir, pub, id_):
             os.makedirs(key_path)
 
     key = os.path.join(pki_dir, 'minions', id_)
-    with salt.utils.fopen(key, 'w+') as fp_:
-        fp_.write(pub)
+    with salt.utils.files.fopen(key, 'w+') as fp_:
+        fp_.write(salt.utils.stringutils.to_str(pub))
 
     oldkey = os.path.join(pki_dir, 'minions_pre', id_)
     if os.path.isfile(oldkey):
-        with salt.utils.fopen(oldkey) as fp_:
+        with salt.utils.files.fopen(oldkey) as fp_:
             if fp_.read() == pub:
                 os.remove(oldkey)
 
@@ -198,7 +204,7 @@ def remove_key(pki_dir, id_):
     key = os.path.join(pki_dir, 'minions', id_)
     if os.path.isfile(key):
         os.remove(key)
-        log.debug('Deleted \'{0}\''.format(key))
+        log.debug('Deleted \'%s\'', key)
 
 
 def rename_key(pki_dir, id_, new_id):
@@ -286,18 +292,20 @@ def salt_config_to_yaml(configuration, line_break='\n'):
     '''
     Return a salt configuration dictionary, master or minion, as a yaml dump
     '''
-    return yaml.dump(configuration,
-                     line_break=line_break,
-                     default_flow_style=False,
-                     Dumper=SafeOrderedDumper)
+    return salt.utils.yaml.safe_dump(
+        configuration,
+        line_break=line_break,
+        default_flow_style=False)
 
 
-def bootstrap(vm_, opts):
+def bootstrap(vm_, opts=None):
     '''
     This is the primary entry point for logging into any system (POSIX or
     Windows) to install Salt. It will make the decision on its own as to which
     deploy function to call.
     '''
+    if opts is None:
+        opts = __opts__
     deploy_config = salt.config.get_cloud_config_value(
         'deploy',
         vm_, opts, default=False)
@@ -311,6 +319,11 @@ def bootstrap(vm_, opts):
             }
         }
 
+    if vm_.get('driver') == 'saltify':
+        saltify_driver = True
+    else:
+        saltify_driver = False
+
     key_filename = salt.config.get_cloud_config_value(
         'key_filename', vm_, opts, search_global=False,
         default=salt.config.get_cloud_config_value(
@@ -346,7 +359,7 @@ def bootstrap(vm_, opts):
 
     ret = {}
 
-    minion_conf = salt.utils.cloud.minion_config(opts, vm_)
+    minion_conf = minion_config(opts, vm_)
     deploy_script_code = os_script(
         salt.config.get_cloud_config_value(
             'os', vm_, opts, default='bootstrap-salt'
@@ -363,7 +376,7 @@ def bootstrap(vm_, opts):
 
     # If we haven't generated any keys yet, do so now.
     if 'pub_key' not in vm_ and 'priv_key' not in vm_:
-        log.debug('Generating keys for \'{0[name]}\''.format(vm_))
+        log.debug('Generating keys for \'%s\'', vm_['name'])
 
         vm_['priv_key'], vm_['pub_key'] = gen_keys(
             salt.config.get_cloud_config_value(
@@ -390,13 +403,14 @@ def bootstrap(vm_, opts):
 
     # NOTE: deploy_kwargs is also used to pass inline_script variable content
     #       to run_inline_script function
+    host = salt.config.get_cloud_config_value('ssh_host', vm_, opts)
     deploy_kwargs = {
         'opts': opts,
-        'host': vm_['ssh_host'],
+        'host': host,
         'port': salt.config.get_cloud_config_value(
             'ssh_port', vm_, opts, default=22
         ),
-        'salt_host': vm_.get('salt_host', vm_['ssh_host']),
+        'salt_host': vm_.get('salt_host', host),
         'username': ssh_username,
         'script': deploy_script_code,
         'inline_script': inline_script_config,
@@ -405,10 +419,7 @@ def bootstrap(vm_, opts):
         'tmp_dir': salt.config.get_cloud_config_value(
             'tmp_dir', vm_, opts, default='/tmp/.saltcloud'
         ),
-        'deploy_command': salt.config.get_cloud_config_value(
-            'deploy_command', vm_, opts,
-            default='/tmp/.saltcloud/deploy.sh',
-        ),
+        'vm_': vm_,
         'start_action': opts['start_action'],
         'parallel': opts['parallel'],
         'sock_dir': opts['sock_dir'],
@@ -438,6 +449,9 @@ def bootstrap(vm_, opts):
             'script_env', vm_, opts
         ),
         'minion_conf': minion_conf,
+        'force_minion_config': salt.config.get_cloud_config_value(
+            'force_minion_config', vm_, opts, default=False
+        ),
         'preseed_minion_keys': vm_.get('preseed_minion_keys', None),
         'display_ssh_output': salt.config.get_cloud_config_value(
             'display_ssh_output', vm_, opts, default=True
@@ -451,9 +465,17 @@ def bootstrap(vm_, opts):
         'maxtries': salt.config.get_cloud_config_value(
             'wait_for_passwd_maxtries', vm_, opts, default=15
         ),
+        'preflight_cmds': salt.config.get_cloud_config_value(
+            'preflight_cmds', vm_, opts, default=[]
+        ),
+        'cloud_grains': {'driver': vm_['driver'],
+                         # XXXXXXXX hack to make backport of 2018.3 to 2016.11.4 work
+                         # 'provider': vm_['provider'],
+                         'profile': vm_['profile']
+                         }
     }
 
-    inline_script_kwargs = deploy_kwargs
+    inline_script_kwargs = deploy_kwargs.copy()  # make a copy at this point
 
     # forward any info about possible ssh gateway to deploy script
     # as some providers need also a 'gateway' configuration
@@ -465,7 +487,7 @@ def bootstrap(vm_, opts):
         deploy_kwargs['make_master'] = True
         deploy_kwargs['master_pub'] = vm_['master_pub']
         deploy_kwargs['master_pem'] = vm_['master_pem']
-        master_conf = salt.utils.cloud.master_config(opts, vm_)
+        master_conf = master_config(opts, vm_)
         deploy_kwargs['master_conf'] = master_conf
 
         if master_conf.get('syndic_master', None):
@@ -475,6 +497,9 @@ def bootstrap(vm_, opts):
         'make_minion', vm_, opts, default=True
     )
 
+    if saltify_driver:
+        deploy_kwargs['wait_for_passwd_maxtries'] = 0  # No need to wait/retry with Saltify
+
     win_installer = salt.config.get_cloud_config_value(
         'win_installer', vm_, opts
     )
@@ -483,7 +508,7 @@ def bootstrap(vm_, opts):
             'smb_port', vm_, opts, default=445
         )
         deploy_kwargs['win_installer'] = win_installer
-        minion = salt.utils.cloud.minion_config(opts, vm_)
+        minion = minion_config(opts, vm_)
         deploy_kwargs['master'] = minion['master']
         deploy_kwargs['username'] = salt.config.get_cloud_config_value(
             'win_username', vm_, opts, default='Administrator'
@@ -499,6 +524,14 @@ def bootstrap(vm_, opts):
         deploy_kwargs['winrm_port'] = salt.config.get_cloud_config_value(
             'winrm_port', vm_, opts, default=5986
         )
+        deploy_kwargs['winrm_use_ssl'] = salt.config.get_cloud_config_value(
+            'winrm_use_ssl', vm_, opts, default=True
+        )
+        deploy_kwargs['winrm_verify_ssl'] = salt.config.get_cloud_config_value(
+            'winrm_verify_ssl', vm_, opts, default=True
+        )
+        if saltify_driver:
+            deploy_kwargs['port_timeout'] = 1  # No need to wait/retry with Saltify
 
     # Store what was used to the deploy the VM
     event_kwargs = copy.deepcopy(deploy_kwargs)
@@ -524,7 +557,7 @@ def bootstrap(vm_, opts):
     if inline_script_config and deploy_config is False:
         inline_script_deployed = run_inline_script(**inline_script_kwargs)
         if inline_script_deployed is not False:
-            log.info('Inline script(s) ha(s|ve) run on {0}'.format(vm_['name']))
+            log.info('Inline script(s) ha(s|ve) run on %s', vm_['name'])
         ret['deployed'] = False
         return ret
     else:
@@ -536,16 +569,16 @@ def bootstrap(vm_, opts):
         if inline_script_config:
             inline_script_deployed = run_inline_script(**inline_script_kwargs)
             if inline_script_deployed is not False:
-                log.info('Inline script(s) ha(s|ve) run on {0}'.format(vm_['name']))
+                log.info('Inline script(s) ha(s|ve) run on %s', vm_['name'])
 
         if deployed is not False:
             ret['deployed'] = True
             if deployed is not True:
                 ret.update(deployed)
-            log.info('Salt installed on {0}'.format(vm_['name']))
+            log.info('Salt installed on %s', vm_['name'])
             return ret
 
-    log.error('Failed to start Salt on host {0}'.format(vm_['name']))
+    log.error('Failed to start Salt on host %s', vm_['name'])
     return {
         'Error': {
             'Not Deployed': 'Failed to start Salt on host {0}'.format(
@@ -591,7 +624,7 @@ def wait_for_fun(fun, timeout=900, **kwargs):
     Wait until a function finishes, or times out
     '''
     start = time.time()
-    log.debug('Attempting function {0}'.format(fun))
+    log.debug('Attempting function %s', fun)
     trycount = 0
     while True:
         trycount += 1
@@ -600,15 +633,11 @@ def wait_for_fun(fun, timeout=900, **kwargs):
             if not isinstance(response, bool):
                 return response
         except Exception as exc:
-            log.debug('Caught exception in wait_for_fun: {0}'.format(exc))
+            log.debug('Caught exception in wait_for_fun: %s', exc)
             time.sleep(1)
-            log.debug(
-                'Retrying function {0} on  (try {1})'.format(
-                    fun, trycount
-                )
-            )
+            log.debug('Retrying function %s on  (try %s)', fun, trycount)
         if time.time() - start > timeout:
-            log.error('Function timed out: {0}'.format(timeout))
+            log.error('Function timed out: %s', timeout)
             return False
 
 
@@ -635,17 +664,12 @@ def wait_for_port(host, port=22, timeout=900, gateway=None):
         test_ssh_host = ssh_gateway
         test_ssh_port = ssh_gateway_port
         log.debug(
-            'Attempting connection to host {0} on port {1} '
-            'via gateway {2} on port {3}'.format(
-                host, port, ssh_gateway, ssh_gateway_port
-            )
+            'Attempting connection to host %s on port %s '
+            'via gateway %s on port %s',
+            host, port, ssh_gateway, ssh_gateway_port
         )
     else:
-        log.debug(
-            'Attempting connection to host {0} on port {1}'.format(
-                host, port
-            )
-        )
+        log.debug('Attempting connection to host %s on port %s', host, port)
     trycount = 0
     while True:
         trycount += 1
@@ -665,33 +689,19 @@ def wait_for_port(host, port=22, timeout=900, gateway=None):
             sock.close()
             break
         except socket.error as exc:
-            log.debug('Caught exception in wait_for_port: {0}'.format(exc))
+            log.debug('Caught exception in wait_for_port: %s', exc)
             time.sleep(1)
             if time.time() - start > timeout:
-                log.error('Port connection timed out: {0}'.format(timeout))
+                log.error('Port connection timed out: %s', timeout)
                 return False
-            if not gateway:
-                log.debug(
-                    'Retrying connection to host {0} on port {1} '
-                    '(try {2})'.format(
-                        test_ssh_host, test_ssh_port, trycount
-                    )
-                )
-            else:
-                log.debug(
-                    'Retrying connection to Gateway {0} on port {1} '
-                    '(try {2})'.format(
-                        test_ssh_host, test_ssh_port, trycount
-                    )
-                )
+            log.debug(
+                'Retrying connection to %s %s on port %s (try %s)',
+                'gateway' if gateway else 'host', test_ssh_host, test_ssh_port, trycount
+            )
     if not gateway:
         return True
     # Let the user know that his gateway is good!
-    log.debug(
-        'Gateway {0} on port {1} is reachable.'.format(
-            test_ssh_host, test_ssh_port
-        )
-    )
+    log.debug('Gateway %s on port %s is reachable.', test_ssh_host, test_ssh_port)
 
     # Now we need to test the host via the gateway.
     # We will use netcat on the gateway to test the port
@@ -730,7 +740,7 @@ def wait_for_port(host, port=22, timeout=900, gateway=None):
         ' '.join(ssh_args), gateway['ssh_gateway_user'], ssh_gateway,
         ssh_gateway_port, pipes.quote(command)
     )
-    log.debug('SSH command: \'{0}\''.format(cmd))
+    log.debug('SSH command: \'%s\'', cmd)
 
     kwargs = {'display_ssh_output': False,
               'password': gateway.get('ssh_gateway_password', None)}
@@ -748,7 +758,7 @@ def wait_for_port(host, port=22, timeout=900, gateway=None):
                 gateway_retries -= 1
                 log.error(
                     'Gateway usage seems to be broken, '
-                    'password error ? Tries left: {0}'.format(gateway_retries))
+                    'password error ? Tries left: %s', gateway_retries)
             if not gateway_retries:
                 raise SaltCloudExecutionFailure(
                     'SSH gateway is reachable but we can not login')
@@ -761,14 +771,12 @@ def wait_for_port(host, port=22, timeout=900, gateway=None):
                 return True
         time.sleep(1)
         if time.time() - start > timeout:
-            log.error('Port connection timed out: {0}'.format(timeout))
+            log.error('Port connection timed out: %s', timeout)
             return False
         log.debug(
-            'Retrying connection to host {0} on port {1} '
-            'via gateway {2} on port {3}. (try {4})'.format(
-                host, port, ssh_gateway, ssh_gateway_port,
-                trycount
-            )
+            'Retrying connection to host %s on port %s '
+            'via gateway %s on port %s. (try %s)',
+            host, port, ssh_gateway, ssh_gateway_port, trycount
         )
 
 
@@ -778,10 +786,8 @@ def wait_for_winexesvc(host, port, username, password, timeout=900):
     '''
     start = time.time()
     log.debug(
-        'Attempting winexe connection to host {0} on port {1}'.format(
-            host,
-            port
-        )
+        'Attempting winexe connection to host %s on port %s',
+        host, port
     )
     creds = "-U '{0}%{1}' //{2}".format(
         username,
@@ -805,60 +811,62 @@ def wait_for_winexesvc(host, port, username, password, timeout=900):
             if ret_code == 0:
                 log.debug('winexe connected...')
                 return True
-            log.debug('Return code was {0}'.format(ret_code))
-            time.sleep(1)
+            log.debug('Return code was %s', ret_code)
         except socket.error as exc:
-            log.debug('Caught exception in wait_for_winexesvc: {0}'.format(exc))
-            time.sleep(1)
-            if time.time() - start > timeout:
-                log.error('winexe connection timed out: {0}'.format(timeout))
-                return False
-            log.debug(
-                'Retrying winexe connection to host {0} on port {1} '
-                '(try {2})'.format(
-                    host,
-                    port,
-                    try_count
-                )
-            )
+            log.debug('Caught exception in wait_for_winexesvc: %s', exc)
+
+        if time.time() - start > timeout:
+            log.error('winexe connection timed out: %s', timeout)
+            return False
+        log.debug(
+            'Retrying winexe connection to host %s on port %s (try %s)',
+            host, port, try_count
+        )
+        time.sleep(1)
 
 
-def wait_for_winrm(host, port, username, password, timeout=900):
+def wait_for_winrm(host, port, username, password, timeout=900, use_ssl=True, verify=True):
     '''
     Wait until WinRM connection can be established.
     '''
     start = time.time()
     log.debug(
-        'Attempting WinRM connection to host {0} on port {1}'.format(
-            host, port
-        )
+        'Attempting WinRM connection to host %s on port %s',
+        host, port
     )
+    transport = 'ssl'
+    if not use_ssl:
+        transport = 'plaintext'
     trycount = 0
     while True:
         trycount += 1
         try:
-            s = winrm.Session(host, auth=(username, password), transport='ssl')
+            winrm_kwargs = {'target': host,
+                            'auth': (username, password),
+                            'transport': transport}
+            if not verify:
+                log.debug("SSL validation for WinRM disabled.")
+                winrm_kwargs['server_cert_validation'] = 'ignore'
+            s = winrm.Session(**winrm_kwargs)
             if hasattr(s.protocol, 'set_timeout'):
                 s.protocol.set_timeout(15)
-            log.trace('WinRM endpoint url: {0}'.format(s.url))
+            log.trace('WinRM endpoint url: %s', s.url)
             r = s.run_cmd('sc query winrm')
             if r.status_code == 0:
                 log.debug('WinRM session connected...')
                 return s
-            log.debug('Return code was {0}'.format(r.status_code))
-            time.sleep(1)
+            log.debug('Return code was %s', r.status_code)
         except WinRMTransportError as exc:
-            log.debug('Caught exception in wait_for_winrm: {0}'.format(exc))
-            if time.time() - start > timeout:
-                log.error('WinRM connection timed out: {0}'.format(timeout))
-                return None
-            log.debug(
-                'Retrying WinRM connection to host {0} on port {1} '
-                '(try {2})'.format(
-                    host, port, trycount
-                )
-            )
-            time.sleep(1)
+            log.debug('Caught exception in wait_for_winrm: %s', exc)
+
+        if time.time() - start > timeout:
+            log.error('WinRM connection timed out: %s', timeout)
+            return None
+        log.debug(
+            'Retrying WinRM connection to host %s on port %s (try %s)',
+            host, port, trycount
+        )
+        time.sleep(1)
 
 
 def validate_windows_cred(host,
@@ -879,7 +887,7 @@ def validate_windows_cred(host,
         host
     )
 
-    for i in xrange(retries):
+    for i in range(retries):
         ret_code = win_cmd(
             cmd,
             logging_command=logging_cmd
@@ -923,16 +931,15 @@ def wait_for_passwd(host, port=22, ssh_timeout=15, username='root',
                         )
                     )
                 kwargs['key_filename'] = key_filename
-                log.debug('Using {0} as the key_filename'.format(key_filename))
+                log.debug('Using %s as the key_filename', key_filename)
             elif password:
                 kwargs['password'] = password
                 log.debug('Using password authentication')
 
             trycount += 1
             log.debug(
-                'Attempting to authenticate as {0} (try {1} of {2})'.format(
-                    username, trycount, maxtries
-                )
+                'Attempting to authenticate as %s (try %s of %s)',
+                username, trycount, maxtries
             )
 
             status = root_cmd('date', tty=False, sudo=False, **kwargs)
@@ -942,11 +949,7 @@ def wait_for_passwd(host, port=22, ssh_timeout=15, username='root',
                     time.sleep(trysleep)
                     continue
 
-                log.error(
-                    'Authentication failed: status code {0}'.format(
-                        status
-                    )
-                )
+                log.error('Authentication failed: status code %s', status)
                 return False
             if connectfail is False:
                 return True
@@ -984,6 +987,8 @@ def deploy_windows(host,
                    master_sign_pub_file=None,
                    use_winrm=False,
                    winrm_port=5986,
+                   winrm_use_ssl=True,
+                   winrm_verify_ssl=True,
                    **kwargs):
     '''
     Copy the install files to a remote Windows box, and execute them
@@ -996,8 +1001,8 @@ def deploy_windows(host,
         return False
 
     starttime = time.mktime(time.localtime())
-    log.debug('Deploying {0} at {1} (Windows)'.format(host, starttime))
-    log.trace('HAS_WINRM: {0}, use_winrm: {1}'.format(HAS_WINRM, use_winrm))
+    log.debug('Deploying %s at %s (Windows)', host, starttime)
+    log.trace('HAS_WINRM: %s, use_winrm: %s', HAS_WINRM, use_winrm)
 
     port_available = wait_for_port(host=host, port=port, timeout=port_timeout * 60)
 
@@ -1009,8 +1014,9 @@ def deploy_windows(host,
 
     if HAS_WINRM and use_winrm:
         winrm_session = wait_for_winrm(host=host, port=winrm_port,
-                                           username=username, password=password,
-                                           timeout=port_timeout * 60)
+                                       username=username, password=password,
+                                       timeout=port_timeout * 60, use_ssl=winrm_use_ssl,
+                                       verify=winrm_verify_ssl)
         if winrm_session is not None:
             service_available = True
     else:
@@ -1019,12 +1025,8 @@ def deploy_windows(host,
                                                timeout=port_timeout * 60)
 
     if port_available and service_available:
-        log.debug('SMB port {0} on {1} is available'.format(port, host))
-        log.debug(
-            'Logging into {0}:{1} as {2}'.format(
-                host, port, username
-            )
-        )
+        log.debug('SMB port %s on %s is available', port, host)
+        log.debug('Logging into %s:%s as %s', host, port, username)
         newtimeout = timeout - (time.mktime(time.localtime()) - starttime)
 
         smb_conn = salt.utils.smb.get_conn(host, username, password)
@@ -1056,12 +1058,12 @@ def deploy_windows(host,
 
         if master_sign_pub_file:
             # Read master-sign.pub file
-            log.debug("Copying master_sign.pub file from {0} to minion".format(master_sign_pub_file))
+            log.debug("Copying master_sign.pub file from %s to minion", master_sign_pub_file)
             try:
-                with salt.utils.fopen(master_sign_pub_file, 'rb') as master_sign_fh:
+                with salt.utils.files.fopen(master_sign_pub_file, 'rb') as master_sign_fh:
                     smb_conn.putFile('C$', 'salt\\conf\\pki\\minion\\master_sign.pub', master_sign_fh.read)
             except Exception as e:
-                log.debug("Exception copying master_sign.pub file {0} to minion".format(master_sign_pub_file))
+                log.debug("Exception copying master_sign.pub file %s to minion", master_sign_pub_file)
 
         # Copy over win_installer
         # win_installer refers to a file such as:
@@ -1070,7 +1072,7 @@ def deploy_windows(host,
         comps = win_installer.split('/')
         local_path = '/'.join(comps[:-1])
         installer = comps[-1]
-        with salt.utils.fopen(win_installer, 'rb') as inst_fh:
+        with salt.utils.files.fopen(win_installer, 'rb') as inst_fh:
             smb_conn.putFile('C$', 'salttemp/{0}'.format(installer), inst_fh.read)
 
         if use_winrm:
@@ -1129,8 +1131,11 @@ def deploy_windows(host,
         # Delete C:\salttmp\ and installer file
         # Unless keep_tmp is True
         if not keep_tmp:
-            smb_conn.deleteFile('C$', 'salttemp/{0}'.format(installer))
-            smb_conn.deleteDirectory('C$', 'salttemp')
+            if use_winrm:
+                winrm_cmd(winrm_session, 'rmdir', ['/Q', '/S', 'C:\\salttemp\\'])
+            else:
+                smb_conn.deleteFile('C$', 'salttemp/{0}'.format(installer))
+                smb_conn.deleteDirectory('C$', 'salttemp')
         # Shell out to winexe to ensure salt-minion service started
         if use_winrm:
             winrm_cmd(winrm_session, 'sc', ['stop', 'salt-minion'])
@@ -1201,20 +1206,26 @@ def deploy_script(host,
                   sudo_password=None,
                   sudo=False,
                   tty=None,
-                  deploy_command='/tmp/.saltcloud/deploy.sh',
+                  vm_=None,
                   opts=None,
                   tmp_dir='/tmp/.saltcloud',
                   file_map=None,
                   master_sign_pub_file=None,
+                  cloud_grains=None,
+                  force_minion_config=False,
                   **kwargs):
     '''
     Copy a deploy script to a remote server, execute it, and remove it
     '''
     if not isinstance(opts, dict):
         opts = {}
+    vm_ = vm_ or {}  # if None, default to empty dict
+    cloud_grains = cloud_grains or {}
 
     tmp_dir = '{0}-{1}'.format(tmp_dir.rstrip('/'), uuid.uuid4())
-    deploy_command = os.path.join(tmp_dir, 'deploy.sh')
+    deploy_command = salt.config.get_cloud_config_value(
+        'deploy_command', vm_, opts,
+        default=os.path.join(tmp_dir, 'deploy.sh'))
     if key_filename is not None and not os.path.isfile(key_filename):
         raise SaltCloudConfigError(
             'The defined key_filename \'{0}\' does not exist'.format(
@@ -1226,14 +1237,16 @@ def deploy_script(host,
     if 'gateway' in kwargs:
         gateway = kwargs['gateway']
 
-    starttime = time.mktime(time.localtime())
-    log.debug('Deploying {0} at {1}'.format(host, starttime))
-
+    starttime = time.localtime()
+    log.debug(
+        'Deploying %s at %s',
+        host, time.strftime('%Y-%m-%d %H:%M:%S', starttime)
+    )
     known_hosts_file = kwargs.get('known_hosts_file', '/dev/null')
     hard_timeout = opts.get('hard_timeout', None)
 
     if wait_for_port(host=host, port=port, gateway=gateway):
-        log.debug('SSH port {0} on {1} is available'.format(port, host))
+        log.debug('SSH port %s on %s is available', port, host)
         if wait_for_passwd(host, port=port, username=username,
                            password=password, key_filename=key_filename,
                            ssh_timeout=ssh_timeout,
@@ -1241,11 +1254,7 @@ def deploy_script(host,
                            gateway=gateway, known_hosts_file=known_hosts_file,
                            maxtries=maxtries, hard_timeout=hard_timeout):
 
-            log.debug(
-                'Logging into {0}:{1} as {2}'.format(
-                    host, port, username
-                )
-            )
+            log.debug('Logging into %s:%s as %s', host, port, username)
             ssh_kwargs = {
                 'hostname': host,
                 'port': port,
@@ -1260,7 +1269,7 @@ def deploy_script(host,
                 ssh_kwargs['ssh_gateway_key'] = gateway['ssh_gateway_key']
                 ssh_kwargs['ssh_gateway_user'] = gateway['ssh_gateway_user']
             if key_filename:
-                log.debug('Using {0} as the key_filename'.format(key_filename))
+                log.debug('Using %s as the key_filename', key_filename)
                 ssh_kwargs['key_filename'] = key_filename
             elif password and kwargs.get('has_ssh_agent', False) is False:
                 ssh_kwargs['password'] = password
@@ -1299,10 +1308,9 @@ def deploy_script(host,
                 remote_file = file_map[map_item]
                 if not os.path.exists(map_item):
                     log.error(
-                        'The local file "{0}" does not exist, and will not be '
-                        'copied to "{1}" on the target system'.format(
-                            local_file, remote_file
-                        )
+                        'The local file "%s" does not exist, and will not be '
+                        'copied to "%s" on the target system',
+                        local_file, remote_file
                     )
                     file_map_fail.append({local_file: remote_file})
                     continue
